# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# config.py
#  
# fichier de configuration du backend zephir
#       
###########################################################################
from zephir.config import *

# paramètres de connexion à la base postgresql

DB_HOST = "127.0.0.1"
DB_USER = "zephir"
DB_NAME = "zephir"
# récupération du mdp postgresql pour zephir (possible seulement pour root)
f_pwd = '/usr/share/zephir/utils/conf_db'
try:
    execfile(f_pwd)
    assert DB_PASSWD
except:
    DB_PASSWD = ""

# paths 
PATH_MODULES = PATH_ZEPHIR+'modules/'
TEMPLATE_DIR = ROOT_DIR + 'backend/template/'

# fonctions utiles

def u(objet):
    if type(objet) == list:
        l = []
        for item in objet:
            l.append(u(item))
        return l
    if type(objet) == tuple:
        l = []
        for item in objet:
            l.append(u(item))
        return l
    if type(objet) == dict:
        dico={}
        for cle in objet.keys():
            dico[cle] = u(objet[cle])
        return dico
    if type(objet) == str:
        try:
            string = unicode(objet,charset)
        except:
            string = unicode(objet,'ISO-8859-1').encode(charset)
        return string
    return objet

# template de configuration uucp pour un serveur

CONFIG_UUCP="""# configuration du serveur %s
system %s
call-login %s
call-password %s
time any
port tcp
pubdir /var/spool/uucppublic
protocol-parameter g timeout 20
protocol-parameter g retries 10
remote-send ~
remote-receive ~
local-receive ~
local-send /
"""

FILE_SECTION = """# section 1
# liste des fichiers à sauvegarder+# (ne pas modifier sauf pour créer ou mettre à jour la variante)"""
RPM_SECTION = """# section 2
# inscrire les noms des paquetages qui seront installés à la mise à jour du serveur
# (ils doivent être présents sur le serveur de mise à jour)"""

holded_packages = ["^linux-.*server$","^linux-.*generic$"]

migration_files = {'amon':{'files':[('filtres-users','filtres-users',True),
                                    ('serialize_btn.srz','serialize_btn.srz',False),
                                    ('local','local',False),
                                    ('perso','perso',False),
                                    ('tmp','tmp',True),
                                    ('horaires.txt','tmp/horaires.txt',True)],
                           'rights':[('filtres-users','','www-data','www-data','0644'),
                                     ('local','-R','www-data','proxy','0755'),
                                     ('local/*','','www-data','proxy','0644'),
                                     ('local/liste_blanche','-R','www-data','proxy','0755'),
                                     ('local/liste_blanche/*','','www-data','proxy','0644'),
                                     ('tmp','','www-data','www-data','0777'),
                                     ('tmp/*','','www-data','www-data','0644'),
                                     ('serialize_btn.srz','','www-data','www-data','0644')],
                           'exclude':['rapport-maj.html','blacklist-date.txt','Reconf.log']}
                  }
