#!/usr/bin/env python
# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# lanceur.py
#  
# chargement et lancement des agents zephir (deprecated)
#       
###########################################################################
import os,random
from twisted.internet import utils, reactor

from zephir.monitor.config import Config

from zephir.monitor import website
try:
    import zephir.zephir_conf.zephir_conf as conf_zeph
    from zephir.lib_zephir import zephir, convert
except:
    # serveur non enregistré sur zephir
    pass

class Agent:
    """Appelle un agent
    """
    def __init__(self, name, delay):
        self.name = name
        self.xml_filename = Config().get_xml_name(self.name)
        self.delay = delay
        # activation de l'agent
        self._run_agent()
        
    def _run_agent(self):
        try:
            adresse_zephir = conf_zeph.adresse_zephir
        except:
            # serveur non enregistré sur zephir
            pass
        else:
            retour=os.system(Config().get_agent_script(self.name))

        reactor.callLater(self.delay, self._run_agent)

    def change_delay(self, delay):
        """Modifie en live le nouveau délai
        """
        self.delay = delay

class Lanceur:
    """Récupère la liste des agents et Créée les objets agent correspondant 
    """
    def __init__(self):
        fh = open('/etc/eole/version','r')
        version = fh.read()
        fh.close()
        # on garde seulement le nom du module
        module = version[:version.index('-')]
        # on utilise le fichier correspondant au module
        os.system('cd %s;cp %s.cfg agents.cfg' % ('/usr/share/zephir/monitor',module))
        self.agent_list = Config().get_agent_list()
    
    def create(self):
        """Création effective des instances d'agents
        """
        for agent in self.agent_list:
            Agent(agent, Config().get_agent_time(agent))

    def run_website(self):
        """Lancement de la génération du site web
           et envoi à zephir
        """
        # lancement toutes les X minutes (défini dans la conf zephir)
        conf_ok = 1
        # timeout par défaut
        timeout = 600
        try:
            reload(conf_zeph)
            adresse_zephir = conf_zeph.adresse_zephir
            # vérification sur zephir du délai de connexion
            timeout = convert(zephir.serveurs.get_timeout(conf_zeph.id_serveur)[1])
        except:
            conf_ok = 0

        reactor.callLater(timeout, self.run_website)
        if conf_ok == 1:
            # creation du site
            web = website.Site()
            # création de l'archive pour uucp
            web.send_zephir()
    
if __name__ == "__main__":
    lance = Lanceur()
    lance.create()
    # on attend entre 1 et x minutes pour le premier lancement
    # (x= delai demandé enrtre chaque connexion)
    try:
        timeout = convert(zephir.serveurs.get_timeout(conf_zeph.id_serveur)[1])
    except:
        # timeout non enregistré
        timeout = 600
    delay = random.randrange(60,timeout)
    reactor.callLater(delay, lance.run_website)
    reactor.run()
